import es, playerlib, usermsg
import msglib
reload(msglib)
import re

# GenericPrinter class provides parsing of messages and a
# factory method to create an AdList for a subclassing printer
class GenericPrinter:
	users = '#all'
	__pattern = re.compile('({([a-zA-Z_]+)})')

	@classmethod
	def __replace(cls,match):
		return str(msglib.getDetail(match.group(2)))

	@classmethod
	def __parseMsg(cls,msg):
		return re.sub(cls.__pattern,cls.__replace,msg)
	
	@classmethod
	def show(cls,msg,ignore):
		cls.realShow(cls.__parseMsg(msg),ignore)
	
# Printer instances

# Printer for HUDHint messages
class HUDHintPrinter(GenericPrinter):
	@classmethod
	def realShow(cls,msg,ignore):
		usermsg.hudhint('#all',msg)

# Printer for topleft messages
class TopTexPrinter(GenericPrinter):
	@classmethod
	def realShow(cls,msg,ignore):
		for userid in playerlib.getUseridList('#all'):
			es.toptext(userid,3,'#red',msg)

# Printer for textarea messages
class TextAreaPrinter(GenericPrinter):
	@classmethod
	def realShow(cls,msg,ignore):
		es.msg('#multi',msg)

# Printer for center messages
class CenterPrinter(GenericPrinter):
	@classmethod
	def realShow(cls,msg,ignore):
		usermsg.centermsg(cls.users,msg)

class ConsolePrinter(GenericPrinter):
	@classmethod
	def realShow(cls,msg,ignore):
		usermsg.echo(cls.users,msg)
